import re
from .aggregator import group


def symmetric(latex: str):
    key = 0
    l = re.split(r'(\\left|\\right)', latex)
    for i in range(len(l) - 1, 0, -1):
        if l[i] == '\\right' and l[i + 1].strip('\\').startswith('.'):
            key = 0
        elif l[i] == '\\right':
            key += 1
        elif l[i] == '\\left' and key == 0:
            return l[i + 1].strip('\\').startswith('{')
        elif l[i] == '\\left':
            key -= 1


def _absolute(maple: str):
    # mp = re.split(r'(\|)([+-/*=])',maple)
    if maple.count('|') > 1 and '||' not in maple:
        right = 0
        left = 0
        for r in range(right, len(maple)):
            if maple[r] == '|':
                right = r
                break
        for l in range(len(maple) - 1, left, -1):
            if maple[l] == '|':
                left = l
                break
        if maple[right + 1:left] not in '+-/*=·⋅' and not maple[right + 1:left].isupper():
            maple = maple[:right] + 'abs(' + maple[right + 1:left] + ')' + maple[left + 1:]
        elif maple[right + 1:left] not in '+-/*=·⋅' and maple[right + 1:left].isupper():
            maple = maple[:right] + '#' + maple[right + 1:left] + '#' + maple[left + 1:]
        return _absolute(maple)
    return maple


def _t1(maple: str):
    if maple.count('|') % 2 != 0:
        maple = maple.replace('||', '#|')
    return maple


# 旧版的绝对值  舍弃
def __absolute(maple: str):
    if re.search('\|\|.*\|\|', maple):
        return maple
    if maple.count('|') == 2 and not re.search(r'\|(.*?)\|', maple).group().isupper() and \
            not re.findall(r'[,{}=]', re.search(r'\|(.*?)\|', maple).group()):
        return re.sub(r'\|(.*?)\|', r'abs(\1)', maple)

    mp_list = [_t1(i) for i in re.split(r'(\|)([·⋅+-/*=⩽⩾<>])|([，,;])', maple) if i]

    for i in range(len(mp_list)):
        if mp_list[i] == '|' and i != 0:
            mp_list[i - 1] = mp_list[i - 1] + '|'
    maple = ''.join([_absolute(i) for i in mp_list if i != '|'])
    if mp_list[0] == '|':
        maple = '|' + maple
    return maple.replace('#', '|')


def absolute(s):
    inx = []
    for i in range(len(s)):
        if s[i] == "|":
            inx.append(i)
    if len(inx) > 1 and len(inx) % 2 == 0:
        e = inx.pop(-1)
        b = inx.pop(-1)
        if re.search('}.*?{',s[b + 1:e]):
            return s
        s = s.replace(s[b:e + 1], 'abs(' + s[b + 1:e] + ')')
        if len(inx) > 1:
            s = absolute(s)
    return s


def double(matched):
    value = matched.group('value')
    if re.search('[+\-*/]', value):
        if not re.search('[,，;；。><]', value):
            return str(value).replace('[', '(').replace(']', ')')

    return value


def zhongkuohao(maple: str):
    if re.search(r'\[.*?\]', maple):
        s = re.search(r'\[.*?\]', maple).group()
        if s:
            if re.search('[fg]\([^/,，]*?\)', s):
                maple = re.sub(r'\[(.*?)\]', r'(\1)', maple)
                # maple = maple.replace(']', ')')

    maple = re.sub('(?P<value>\[.*?])', double, maple)

    if 'log(' in maple:
        start = re.search('log\(', maple).end()-1
        b = 0
        end = 0
        for i in range(start, len(maple)):
            if maple[i] == '(':
                b += 1
            elif maple[i] == ')':
                b -= 1
            if b == 0:
                end = i
                break
        if start and  end:
            maple = maple.replace(maple[start:end + 1], '[%s]' % (maple[start + 1:end]))
    return maple


def multip(maple: str):
    maple = re.sub(r'([0-9])([ABCifghkabcmnxXYZyzepθπαφβωλt])', r'\1*\2', maple)  # 乘法
    maple = re.sub(r'([πkabcmnxyzωλte])([abcdklmnrxyzepθπαφβωλti])', r'\1*\2', maple)  # 乘法问题
    maple = re.sub(r'([0-9kabcmnxyztei])(log|ln|sin|cos|tan|cot|lg|sqrt|abs|[fgFG]\()', r'\1*\2', maple)
    maple = re.sub(r'([^a-z])([kabcmnxyzeti])(\([^)><=⩽⩾≠∈,;]+\))', r'\1\2*\3', maple)
    maple = re.sub(r'(\([^)><=⩽⩾≠∈,;]+\))([abcmnxyzeki]|log|ln|sin|cos|tan|cot|lg|sqrt|abs|[fg]\()', r'\1*\2', maple)
    maple = re.sub(r'(\)[^)><=⩽⩾≠∈,;]*\))([abcmnxyzeki]|log|ln|sin|cos|tan|cot|lg|sqrt|abs|[fg]\()', r'\1*\2', maple)
    maple = re.sub(r'(\([^)><=⩽⩾≠∈,;]+\))(\([^)><=⩽⩾≠∈,;]+\))', r'\1*\2', maple)
    maple = re.sub(r'([0-9x])(\([^)><=⩽⩾≠∈,;]+\))', r'\1*\2', maple)
    maple = re.sub(r'(\([^)><=⩽⩾≠∈,;]+\))(\d)', r'\1*\2', maple)
    maple = re.sub(r'\)([0-9abci])', r')*\1', maple)
    maple = re.sub(r'__(\d)\*\(', r'__\1(', maple)

    if not re.search(r'<.*?>', maple):
        maple = re.sub('⋅', '*', maple)
    maple = maple.replace('m*a*x', 'max')
    maple = maple.replace('ma*x', 'max')
    maple = maple.replace('m*ax', 'max')
    maple = maple.replace('m*in', 'min')  # tjt新增
    maple = maple.replace('a*bs', 'abs')
    maple = maple.replace('t*an', 'tan')
    maple = maple.replace('()', '')
    maple = maple.replace('___', '__')
    maple = maple.replace(')(f(', ')*(f(')

    maple = re.sub(r'([ABCi0-9π])(sin|cos|tan|cot)', r'\1*\2', maple)
    maple = re.sub(r'([ABCabci0-9π])(f\(.*?\)|g\(.*?\)|h\(.*?\))', r'\1*\2', maple)
    maple = re.sub(r'([ABCabci0-9π])(f\^|g\^|h\^)', r'\1*\2', maple)
    # maple = maple.strip(';.')
    return maple


def sin_cos(s):
    s = re.sub('sin([ABCi0-9ωφxπαβ+\-*/]+)', r'sin(\1)', s)
    s = re.sub('cos([ABCi0-9ωφxπαβ+\-*/]+)', r'cos(\1)', s)
    s = re.sub('tan([ABCi0-9ωφxπαβ+\-*/]+)', r'tan(\1)', s)
    s = re.sub('cot([ABCi0-9ωφxπαβ+\-*/]+)', r'cot(\1)', s)
    s = s.replace('-)', ')-').replace('+)', ')+')
    return s


def danwei(s):
    l1 = [('{J}', 'J'), ('{c*m/s}', 'cm/s'), ('{kg/m^3}', 'kg/m^3'), ('{N}', 'N'), ('{Hz}', 'Hz'), ('{k*m^2}', 'km^2'),
          ('{c*m^2}', 'cm^2'), ('{㎛}', '㎛'), ('{k*m/h}', 'km/h'), ('{dm^2}', 'dm^2'), ('{dm}', 'dm'), ('{t}', 't'),
          ('{k*m^3}', 'km^3'), ('{h}', 'h'), ('{m*m/s}', 'mm/s'), ('{dB}', 'dB'), ('{m*m^3}', 'mm^3'), ('{mA}', 'mA'),
          ('{㎛^2}', '㎛^2'), ('{m/s}', 'm/s'), ('{c*m}', 'cm'), ('{k*m}', 'km'), ('{V}', 'V'), ('{m^2}', 'm^2'),
          ('{MPa}', 'MPa'), ('{m*m}', 'mm'), ('{℃}', '℃'), ('{㎚^3}', '㎚^3'), ('{L}', 'L'), ('{㎚^2}', '㎚^2'),
          ('{㎍}', '㎍'),
          ('{min}', 'min'), ('{W}', 'W'), ('{Ω}', 'Ω'), ('{s}', 's'), ('{m}', 'm'), ('{g}', 'g'), ('{Pa}', 'Pa'),
          ('{dm^3}', 'dm^3'), ('{℉}', '℉'), ('{kg}', 'kg'), ('{㎚}', '㎚'), ('{m*m^2}', 'mm^2'), ('{㎛^3}', '㎛^3'),
          ('{m^3}', 'm^3'), ('{mg}', 'mg'), ('{c*m^3}', 'cm^3'), ('{A}', 'A'), ('{mL}', 'mL')]
    l2 = [('c*m/s', 'cm/s'), ('k*m^2', 'km^2'), ('c*m^2', 'cm^2'), ('k*m/h', 'km/h'), ('k*m^3', 'km^3'),
          ('m*m/s', 'mm/s'), ('i*mg', 'img'), (r'^)', r')^'), ('f^(-1)*', '反函数f'), ('g^(-1)*', '反函数g'),
          ('h^(-1)*', '反函数h'),
          ('m*m^3', 'mm^3'), ('c*m', 'cm'), ('k*m', 'km'), ('m*m', 'mm'), ('m*m^2', 'mm^2'), ('c*m^3', 'cm^3')]
    for i, j in l1:
        s = s.replace(i, j)

    for i, j in l2:
        s = s.replace(i, j)
    return s


def last_replace(s):
    if s.count(']') - s.count('[')>0:
        s = s.replace(')]',')')

    if re.search('\{.*\}',s):
        s= s.replace(r'\\',';')

    if re.search(r'log\[.*?]',s):
        s = re.sub(r'log\[(.*?)]([^=(]*?)$',r'log[\1](\2)',s)
        s = re.sub(r'log\[(.*?)]([^=(]*?)=',r'log[\1](\2)=',s)

    while s.count('{') != s.count('}') and '{{' in s:
        s=s.replace('{{','{')
    while s.count('{') != s.count('}') and '}}' in s:
        s=s.replace('}}','}')
    li = [(r'log\(\((.*?)\)\)', r'log[\1]'),
          (r'log\((.*?)\)\*\(', r'log[\1]('),
          (r';;', r';'),
          (r'*)*',r')*'),
          ('([fgh])\^(\d)\*\((.*?)\)', r'(\1(\3))^\2'),
          ('lg\(\^(\d)\*(.*?)\)',r'(lg(\2))^\1'),
          ]
    for k, v in li:
        try:
            if re.search(k, s):
                s = re.sub(k, v, s)
        except:
            ...

    if '反函数' in s:
        s='反函数'+s.replace('反函数','')
    if '一拔' in s:
        s='一拔'+s.replace('一拔','')

    return s


def wap(func):
    def inner(*args, **kwargs):
        s = func(*args, **kwargs)
        s = sin_cos(s)
        s = absolute(s)
        s = zhongkuohao(s)
        s = multip(s)
        s = danwei(s)
        s = last_replace(s)
        return s

    return inner


def format_latex(latex: str):
    latex = latex.strip('$')
    latex = re.sub(r'^\\\[', '', latex)
    latex = re.sub(r'\\\]$', '', latex)
    latex = re.sub(r'&lt;', '<', latex)
    # latex = re.sub(r'\^{\^', '\^{', latex)
    latex = re.sub(r'&gt;', '>', latex)
    latex = re.sub(r'^\[', '【', latex)
    latex = latex.replace(r'^{}', '')
    # latex = re.sub(r'\\log _(\d+)',r'log[\1]',latex)

    # tjt修改---({m}_{1},{{r}^{2}}特殊处理)
    latex = re.sub(r'{([A-Za-z]{1,3})}_{([0-9])}', r'{\1_\2}', latex)
    latex = re.sub(r'{([A-Za-z0-9]{1,3})}\^{([A-Za-z0-9]{1,3})}', r'{\1^\2}', latex)
    # formula_list = ["{[A-Za-z]}_{[0-9]}","{[A-Za-z0-9]}\^{[A-Za-z0-9]}"]
    # re_list = re.findall('|'.join(formula_list), s)
    # if len(re_list) > 0:
    #     latex_list = [ele for ele in re_list if ele.strip() != '']
    #     if len(latex_list) == len(re_list):
    #         latex_list = [ele.replace('}_{','_').replace('}^{','^') 
    #                       for ele in latex_list]
    #         for i in range(len(latex_list)):
    #             s = s.replace(re_list[i], latex_list[i], 1)

    latex = re.sub(r'\\log _{\\sqrt(.*?)}', r'log[sqrt(\1)]', latex)
    latex = re.sub(r'\\log _{([^\\=]*?)}',r'log[\1]',latex)
    # latex = latex.replace(r'_{', '{')
    latex = latex.replace(r'{}', '')
    latex = latex.replace(r'&', '')
    # if re.search(r'\]$', latex):
    #     latex = re.sub(r'\]$', '】', latex)
    #     latex = re.sub(r'\[', '【', latex,1,re.VERBOSE)
    # latex = re.sub(r'^\(', '（', latex)
    # latex = re.sub(r'\)$', '）', latex)
    # latex = re.sub(r'\\sqrt\[(\d+)\]]', r'\root{\1}', latex)
    latex = latex.replace(r'\right.\left.', '')
    latex = latex.replace(r'{\kern 1pt}', '')
    latex = latex.replace(r'\;', '')
    latex = latex.replace(r'\bar', r'\overline')
    latex = latex.replace(r'\overset{\lower0.5em\hbox{$\smash{\scriptscriptstyle\rightharpoonup}$}}', '\overrightarrow')
    latex = latex.replace(r'\lower0.5em', '')
    latex = latex.replace(r'\smash', '')
    latex = latex.replace(r'\user', '')
    # latex = re.sub(r'_(.{1,3})\^', r'\1%%', latex)
    #
    # latex = re.sub(r'_({.*?})\^({.*?})', r'\1%%\2', latex)
    # latex = re.sub(r'_({.*?})\^(.)', r'\1%%\2', latex)

    # latex = re.sub(r'_(.{1,3})\^', r'\1%%', latex)
    latex = re.sub(r'_(.{1,3})\^([^{])', r'\1%%', latex)
    latex = re.sub(r'_(.{1,3})\^({[^{}]*?})', r'\1%%T@T\2T@T', latex)
    latex = re.sub(r'_(.{1,3})\^({[^{}]*?{[^{}]*?}{[^{}]*?}})', r'\1%%T@T\2T@T', latex) #\int _0^{\frac{\pi }{2}}\left( {\sin x - \cos x} \right)dx
    latex = re.sub(r'_(.{1,3})\^({[^{}]*?{{[^{}]*?{[^{}]*?}}}{[^{}]*?}})', r'T@T\1T@T%%T@T\2T@T', latex)  #\int _0^{\frac{{\rm{\pi }}}{4}}dx
    latex = re.sub(r'_({.*?})\^(.)', r'T@T\1T@T%%\2', latex)

    latex = re.sub(r'_({.*?})\^({[^{}]*?{[^{}]*?}{[^{}]*?}})', r'T@T\1T@T%%T@T\2T@T', latex)
    latex = re.sub(r'_({.*?})\^({[^{}]*?})', r'T@T\1T@T%%T@T\2T@T', latex)
    latex = re.sub(r'_({.*?})\^({[^{}]*?{{[^{}]*?{[^{}]*?}}}{[^{}]*?}})', r'T@T\1T@T%%T@T\2T@T', latex)

    latex = re.sub(r'\\begin{array}{\*\{20\}\{c\}\} +\{ *\}.*?\\end\{array\}', '', latex)
    latex = re.sub(r'\{\\begin\{array\}\{\*\{20\}\{l\}\}(.*?)\\end\{array\}', r'\1', latex)
    latex = latex.replace(r'\,', '')
    latex = latex.replace(r'\operatorname', '')
    latex = latex.replace(r'\~', '~')
    latex = latex.replace(r'\limits', '')
    latex = latex.replace(r'\mathop', '')
    latex = re.sub(r'\(([^}]*?)\)\^', r'{(\1)}^', latex)
    latex = re.sub(r'\\left\((.*?)\\right\)\^', r'{(\1)}^', latex)
    if latex.endswith(r'\right.') and symmetric(latex):
        latex = latex.replace(r'\right.', r'\right\}')
    if r'\right.' in latex and r'\left\{' in latex and r'\right\}' not in latex:
        latex = latex.replace(r'\right.', r'\right\}')

    latex = latex.replace(r'%27', r"'")
    latex = latex.replace(r'\left[', r'\left【')
    latex = latex.replace(r'\right]', r'\right】')
    latex = latex.replace(r'\left(', '\left（')
    latex = latex.replace(r'\right)', r'\right）')
    # print(re.search(r'([a-z])_([0-9]) *\^([0-9])',latex))
    latex = re.sub(r'([a-z])_([0-9]) *\^([0-9])', r'\1__\2 ^\3', latex)
    latex = re.sub(r'{\rm{(.*?)}}',r'\1',latex)
    return latex


@wap
def last_clear(s, debug=False):
    BList = (
        # r'([a-z]_[0-9n])([a-z])': r'\1*\2',
        # r'([a-z])_([0-9n]+)': r'\1__\2',
        # r'{([0-9a-zA-Z _=+*/\-><]*?)}': r'\1',  # 减法问题 括里含有等号
        # r'\|': r'∥', #？？？平行
        # r'|.*?|': r'abs(\1)',
        # r'([0-9a-zA-Z])(abs|sin|cos|tan|cot)': r'\1*\2',
        # r'sin\((\d*\*?\w*)\)cos\((\d*\*?\w*)\)': r'sin(\1)*cos(\2)',
        # r'sqrt\((.*?)\)sqrt\((.*?)\)': r'sqrt(\1)*sqrt(\2)',
        # r'sqrt\((.*?)\)sin\((.*?)\)': r'sqrt(\1)*sin(\2)',
        # r'([0-9a-zA-Z])pi': r'\1*pi',
        # r'{([0-9a-zA-Z]+\^[0-9a-zA-Z]+)}': r'\1',
        # r'\)\(': r')*(',
        # r'(\w|\d+)Pi': r'\1*Pi',
        (r'\\left', ''),
        (r'\\right', ''),
        (r',;', r';'),
        (r',\}', r'}'),
        (r';\}', r'}'),
        (r'\.\}', r'}'),
        (r'\{\.', r'{'),
        (r'\{\,', r'{'),
        (r'\{\;', r'{'),
        (r'】', r']'),
        (r'【', r'['),
        (r'（', r'('),
        (r'）', r')'),
        (r'−', r'-'),
        (r'÷', r'/'),
        (r'(lg|ln)(sin|cos|tan)\((.*?)\)', r'\1(\2(\3))'),
        (r'(lg|ln)(sin|cos|tan)([0-9abmnxyzθπαφβA-Z]{1,2})', r'\1(\2(\3))'),
        (r'sin(\d+\^.{1})', r'sin(\1)'),
        (r'cos(\d+\^.{1})', r'cos(\1)'),
        (r'tan(\d+\^.{1})', r'tan(\1)'),
        (r'sin(\^\d)?\(([0-9abmnxyzθπαφβA-Z].*?)\)', r'sin(\2)\1'),
        (r'cos(\^\d)?\(([0-9abmnxyzθπαφβA-Z].*?)\)', r'cos(\2)\1'),
        (r'sin(\^\d)?([0-9abmnxyzθπαφβA-Z]{1,2})', r'sin(\2)\1'),
        (r'cos(\^\d)?([0-9abmnxyzθπαφβA-Z]{1,2})', r'cos(\2)\1'),
        (r'tan([0-9abmnxyzθπαβ]{1,2})', r'tan(\1)'),
        (r'log\[(.*?)\]([^\+\-*/\(\),;\[\]>⩾⩽≤{}≠≥<=lsc]+)', r'log[\1](\2)'),
        (r'ln([^\+\-*=/\(\),;[]+)', r'ln(\1)'),
        (r'lg([^\+\-*=/\(\),;[]+)', r'lg(\1)'),
        (r'log__([1-9a-zA-Z])', r'log[\1]'),
        # (r'C__', r'∁'),
        (r'C__([^0-9])', r'∁\1'),
        (r'∁__', r'∁'),
        (r'≤|⩽', r'<='),
        (r'≥|⩾', r'>='),
        (r'≠', r'<>'),
        (r'x̸⊂', r'⊄'),
        (r'{}', r''),
        (r'^*', r'*'),
        (r'^+', r'+'),
        (r'__\+', r'+'),
        (r'__\*', r'*'),
        (r'__\^', r'^'),
        (r';,', r','),
        (r'×', r'*'),
        (r'﹣', r'-'),
        (r'\)\)\(\(', r'))*(('),
        (r'\)f\(', r')*f('),
        (r'([CAP])([0-9mnk][+-][\dmnk])%%([0-9mnk])', r'\1[\2,\3]'),
        (r'T@T(.*?)T@T%%T@T(.*?)T@T', r'[\1,\2]'),
        (r'([0-9mnk])%%T@T(.*?)T@T', r'[\1,\2]'),
        (r'T@T(.*?)T@T%%([0-9mnk])', r'[\1,\2]'),
        (r'([∑∫])(.*?)%%(.*?)([a-zA-Z(*\-+])', r'\1[\2,\3]\4'),
        (r'([0-9mnk])%%([0-9mnk])([CAP])', r'[\1,\2]*\3'),
        (r'([0-9mnk]*?)%%([0-9mnk]+)', r'[\1,\2]'),
        (r'([n\dk])([CAP]\[.{1,3},.{1,3}\])', r'\1*\2'),
        (r'([fgh])\^(\d+)\*\((.*?)\)', r'\1(\3)^\2'),
        (
            r'([0-9a-zA-Z])(km|m|dm|cm|mm|㎛|㎚|L|mL|t|kg|g|mg|㎍|℃|℉|h|min|s|km/h|m/s|cm/s|mm/s|N|kg/m\^3|km\^2|m\^2|dm\^2|cm\^2|mm\^2|㎛\^2|㎚\^2|km\^3|m\^3|dm\^3|cm\^3|mm\^3|㎛\^3|㎚\^3|Pa|A|mA|MPa|V|Ω|J|W|Hz|dB)$',
            r'\1*{\2}'),

    )
    for k, v in BList:
        try:
            if re.search(k, s):
                s = re.sub(k, v, s)
                if debug:
                    print(k, v, '----->', s)
        except:
            pass
    for k, v in BList:
        try:
            if re.search(k, s):
                s = re.sub(k, v, s)
                if debug:
                    print(k, v, '----->', s)
            return s
        except:
            return ''


if __name__ == '__main__':
    # symmetric(r'f(x) = \left\{ \begin{gathered}    \left| {\lg \left| x \right|} \right|,x \ne 0 \hfill \\    0,x = 0 \hfill \\   \end{gathered}  \right.')

    # s = r'f(x) = \left\{ \begin{gathered}    \left| {\lg \left| x \right|} \right|,x \ne 0 \hfill \\    0,x = 0 \hfill \\   \end{gathered}  \right.'
    # format_latex(s)

    print(group(
        '<p>由<img src="/data/word/wordimg/2021/10/6166561b71f91.png" style="width: 94pt; height: 17.9pt" data-type="math" data-latex="\[1 + f(2x) = 2{f^2}(x)\]" width="125" height="24"/>,得<img src="/data/word/wordimg/2021/10/6166561b72660.png" style="width: 94pt; height: 17.9pt" data-type="math" data-latex="\[f(2x) = 2{f^2}(x) - 1\]" width="125" height="24"/>,联想到<img src="/data/word/wordimg/2021/10/6166561b72cbb.png" style="width: 95.9pt; height: 16.05pt" data-type="math" data-latex="\[\cos 2x = 2{\cos ^2}x - 1\]" width="128" height="21"/>,可推测<img src="/data/word/wordimg/2021/10/6166561b795a1.png" style="width: 70.1pt; height: 16.05pt" data-type="math" data-latex="\[f(x) = \cos \omega x\]" width="93" height="21"/>.</p><p>由<img src="/data/word/wordimg/2021/10/6166561b79e83.png" style="width: 82.05pt; height: 31.15pt" data-type="math" data-latex="\[f(x) = f(x + \frac{\pi }{2})\]" width="109" height="42"/>,得<img src="/data/word/wordimg/2021/10/6166561b7a6b0.png" style="width: 92.1pt; height: 33pt" data-type="math" data-latex="\[\frac{\pi }{2} = k\frac{{2\pi }}{{|\omega |}}(k \in {{\rm{N}}^*})\]" width="123" height="44"/>.则<img src="/data/word/wordimg/2021/10/6166561b7ae2a.png" style="width: 82.05pt; height: 17.9pt" data-type="math" data-latex="\[|\omega | = 4k(k \in {{\rm{N}}^*})\]" width="109" height="24"/>.又<img src="/data/word/wordimg/2021/10/6166561b7b4e6.png" style="width: 54.1pt; height: 31.15pt" data-type="math" data-latex="\[f(\frac{\pi }{4}) \ne - 1\]" width="72" height="42"/>.所以<img src="/data/word/wordimg/2021/10/6166561b7bbec.png" style="width: 110.05pt; height: 16.05pt" data-type="math" data-latex="\[f(x) = \cos (4kx)(k \in Z\]" width="147" height="21"/>,<img src="/data/word/wordimg/2021/10/6166561b82974.png" style="width: 10.05pt; height: 13.85pt" data-type="math" data-latex="\[k\]" width="13" height="18"/>为偶数,且<img src="/data/word/wordimg/2021/10/6166561b83189.png" style="width: 31.15pt; height: 16.05pt" data-type="math" data-latex="\[|k| &gt; 1\]" width="42" height="21"/>)</p>'))
